/* krb5sia.h
 *
 * Luke-karol Petelczyc - luke@cit.uws.edu.au
 *
 * Please see krb5sia.c for more details
 *
 *****/

/* LICENSE

Copyright (c) 2002, Luke-karol Petelczyc
All rights reserved.

Redistribution and use in source and binary forms, with or without 
modification, are permitted provided that the following conditions are met:

	Redistributions of source code must retain the above copyright notice,
	this list of conditions and the following disclaimer. 

	Redistributions in binary form must reproduce the above copyright 
	notice, this list of conditions and the following disclaimer in 
	the documentation and/or other materials provided with the 
	distribution. 

	Neither the name of the University of Western Sydney nor the names
	of its contributors may be used to endorse or promote products 
	derived from this software without specific prior written permission. 

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include <siad.h>
#include <pwd.h>
#include <time.h>

#include <krb5.h>


#define KRB5CCNAME "KRB5CCNAME="
#define MAX(a,b)(((a)>(b))?(a):(b))

struct siakrb5ses
{
  krb5_context *context;
  krb5_ccache cc;
  krb5_principal princ;
  char cachefile[ PATH_MAX ];
  int authedOK;
};

int krb5_siad_ses_init( SIAENTITY *entity, int pkgind );
int krb5_get_passwd( SIAENTITY *e, prompt_t *p );
int krb5_get_uname( SIAENTITY *e, prompt_t *p );
int krb5_siad_ses_init( SIAENTITY *entity, int pkgind );
int krb5_siad_ses_authent( sia_collect_func_t *collect,
			   SIAENTITY *entity,
			   int siastat,
			   int pkgind );
int krb5_siad_ses_reauthent( sia_collect_func_t *collect,
			     SIAENTITY *entity,
			     int siastat,
			     int pkgind );
int krb5_siad_ses_launch( sia_collect_func_t *collect,
			  SIAENTITY *entity,
			  int pkgind );
int krb5_siad_ses_release( SIAENTITY *entity, int pkgind );

int krb5_siad_ses_suauthent( sia_collect_func_t *collect,
			     SIAENTITY *entity,
			     int siastat,
			     int pkgind );
int krb5_siad_chk_user( const char *logname, int checkflag );
int krb5_siad_chg_password( sia_collect_func_t *collect,
			    const char *username,
			    int argc,
			    char **argv );
int krb5_auth( sia_collect_func_t *collect,
	       SIAENTITY *entity,
	       int siastat,
	       int pkgind );
int krb5_cache_config( SIAENTITY *entity, int pkgind );
int krb5_authenticate( SIAENTITY *entity, int pkgind );


